diff --git a/src/backend/nodes/tidbitmap.c b/src/backend/nodes/tidbitmap.c
index c5feacbff4..5086c149ac 100644
--- a/src/backend/nodes/tidbitmap.c
+++ b/src/backend/nodes/tidbitmap.c
@@ -53,7 +53,8 @@
  * the per-page bitmaps variable size.  We just legislate that the size
  * is this:
  */
-#define MAX_TUPLES_PER_PAGE  MaxHeapTuplesPerPage
+#define MAX_TUPLES_PER_PAGE_LIMIT  MaxHeapTuplesPerPageLimit
+#define MAX_TUPLES_PER_PAGE(tdeNonceSize)  MaxHeapTuplesPerPage(tdeNonceSize)
 
 /*
  * When we have to switch over to lossy storage, we use a data structure
@@ -78,7 +79,9 @@
 #define BITNUM(x)	((x) % BITS_PER_BITMAPWORD)
 
 /* number of active words for an exact page: */
-#define WORDS_PER_PAGE	((MAX_TUPLES_PER_PAGE - 1) / BITS_PER_BITMAPWORD + 1)
+#define WORDS_PER_PAGE_LIMIT	((MAX_TUPLES_PER_PAGE_LIMIT - 1) / BITS_PER_BITMAPWORD + 1)
+#define WORDS_PER_PAGE(tdeNonceSize)	((MAX_TUPLES_PER_PAGE(tdeNonceSize) - 1) / BITS_PER_BITMAPWORD + 1)
+
 /* number of active words for a lossy chunk: */
 #define WORDS_PER_CHUNK  ((PAGES_PER_CHUNK - 1) / BITS_PER_BITMAPWORD + 1)
 
@@ -102,7 +105,7 @@ typedef struct PagetableEntry
 	char		status;			/* hash entry status */
 	bool		ischunk;		/* T = lossy storage, F = exact */
 	bool		recheck;		/* should the tuples be rechecked? */
-	bitmapword	words[Max(WORDS_PER_PAGE, WORDS_PER_CHUNK)];
+	bitmapword	words[Max(WORDS_PER_PAGE_LIMIT, WORDS_PER_CHUNK)];
 } PagetableEntry;
 
 /*
@@ -389,7 +392,7 @@ tbm_add_tuples(TIDBitmap *tbm, const ItemPointer tids, int ntids,
 					bitnum;
 
 		/* safety check to ensure we don't overrun bit array bounds */
-		if (off < 1 || off > MAX_TUPLES_PER_PAGE)
+		if (off < 1 || off > MAX_TUPLES_PER_PAGE(tde_nonce_size))
 			elog(ERROR, "tuple offset out of range: %u", off);
 
 		/*
@@ -520,7 +523,7 @@ tbm_union_page(TIDBitmap *a, const PagetableEntry *bpage)
 		else
 		{
 			/* Both pages are exact, merge at the bit level */
-			for (wordnum = 0; wordnum < WORDS_PER_PAGE; wordnum++)
+			for (wordnum = 0; wordnum < WORDS_PER_PAGE(tde_nonce_size); wordnum++)
 				apage->words[wordnum] |= bpage->words[wordnum];
 			apage->recheck |= bpage->recheck;
 		}
@@ -649,7 +652,7 @@ tbm_intersect_page(TIDBitmap *a, PagetableEntry *apage, const TIDBitmap *b)
 		{
 			/* Both pages are exact, merge at the bit level */
 			Assert(!bpage->ischunk);
-			for (wordnum = 0; wordnum < WORDS_PER_PAGE; wordnum++)
+			for (wordnum = 0; wordnum < WORDS_PER_PAGE(tde_nonce_size); wordnum++)
 			{
 				apage->words[wordnum] &= bpage->words[wordnum];
 				if (apage->words[wordnum] != 0)
@@ -696,7 +699,8 @@ tbm_begin_iterate(TIDBitmap *tbm)
 	 * needs of the TBMIterateResult sub-struct.
 	 */
 	iterator = (TBMIterator *) palloc(sizeof(TBMIterator) +
-									  MAX_TUPLES_PER_PAGE * sizeof(OffsetNumber));
+									  MAX_TUPLES_PER_PAGE(tde_nonce_size) *
+									  sizeof(OffsetNumber));
 	iterator->tbm = tbm;
 
 	/*
@@ -912,7 +916,7 @@ tbm_extract_page_tuple(PagetableEntry *page, TBMIterateResult *output)
 	int			wordnum;
 	int			ntuples = 0;
 
-	for (wordnum = 0; wordnum < WORDS_PER_PAGE; wordnum++)
+	for (wordnum = 0; wordnum < WORDS_PER_PAGE(tde_nonce_size); wordnum++)
 	{
 		bitmapword	w = page->words[wordnum];
 
@@ -1471,7 +1475,8 @@ tbm_attach_shared_iterate(dsa_area *dsa, dsa_pointer dp)
 	 * serve the needs of the TBMIterateResult sub-struct.
 	 */
 	iterator = (TBMSharedIterator *) palloc0(sizeof(TBMSharedIterator) +
-											 MAX_TUPLES_PER_PAGE * sizeof(OffsetNumber));
+											 MAX_TUPLES_PER_PAGE(tde_nonce_size) *
+											 sizeof(OffsetNumber));
 
 	istate = (TBMSharedIteratorState *) dsa_get_address(dsa, dp);
 
diff --git a/src/backend/replication/logical/reorderbuffer.c b/src/backend/replication/logical/reorderbuffer.c
index b0ab91cc71..54a8123b30 100644
--- a/src/backend/replication/logical/reorderbuffer.c
+++ b/src/backend/replication/logical/reorderbuffer.c
@@ -4711,7 +4711,7 @@ ReorderBufferToastReplace(ReorderBuffer *rb, ReorderBufferTXN *txn,
 	 * the tuplebuf because attrs[] will point back into the current content.
 	 */
 	tmphtup = heap_form_tuple(desc, attrs, isnull);
-	Assert(newtup->tuple.t_len <= MaxHeapTupleSize);
+	Assert(newtup->tuple.t_len <= MaxHeapTupleSize(tde_nonce_size));
 	Assert(ReorderBufferTupleBufData(newtup) == newtup->tuple.t_data);
 
 	memcpy(newtup->tuple.t_data, tmphtup->t_data, tmphtup->t_len);
diff --git a/src/backend/storage/freespace/freespace.c b/src/backend/storage/freespace/freespace.c
index 8c12dda238..d3d61baec3 100644
--- a/src/backend/storage/freespace/freespace.c
+++ b/src/backend/storage/freespace/freespace.c
@@ -62,7 +62,7 @@
  */
 #define FSM_CATEGORIES	256
 #define FSM_CAT_STEP	(BLCKSZ / FSM_CATEGORIES)
-#define MaxFSMRequestSize	MaxHeapTupleSize
+#define MaxFSMRequestSize(tdeNonceSize)	MaxHeapTupleSize(tdeNonceSize)
 
 /*
  * Depth of the on-disk tree. We need to be able to address 2^32-1 blocks,
@@ -71,9 +71,9 @@
  * this means that 4096 bytes is the smallest BLCKSZ that we can get away
  * with a 3-level tree, and 512 is the smallest we support.
  */
-#define FSM_TREE_DEPTH	((SlotsPerFSMPage >= 1626) ? 3 : 4)
+#define FSM_TREE_DEPTH(tdeNonceSize)	((SlotsPerFSMPage(tdeNonceSize) >= 1626) ? 3 : 4)
 
-#define FSM_ROOT_LEVEL	(FSM_TREE_DEPTH - 1)
+#define FSM_ROOT_LEVEL(tdeNonceSize)	(FSM_TREE_DEPTH(tdeNonceSize) - 1)
 #define FSM_BOTTOM_LEVEL 0
 
 /*
@@ -87,7 +87,7 @@ typedef struct
 } FSMAddress;
 
 /* Address of the root page. */
-static const FSMAddress FSM_ROOT_ADDRESS = {FSM_ROOT_LEVEL, 0};
+static FSMAddress FSM_ROOT_ADDRESS = {0, 0};
 
 /* functions to navigate the tree */
 static FSMAddress fsm_get_child(FSMAddress parent, uint16 slot);
@@ -336,6 +336,8 @@ FreeSpaceMapVacuum(Relation rel)
 {
 	bool		dummy;
 
+	FSM_ROOT_ADDRESS.level = FSM_ROOT_LEVEL(tde_nonce_size);
+
 	/* Recursively scan the tree, starting at the root */
 	(void) fsm_vacuum_page(rel, FSM_ROOT_ADDRESS,
 						   (BlockNumber) 0, InvalidBlockNumber,
@@ -357,7 +359,11 @@ FreeSpaceMapVacuumRange(Relation rel, BlockNumber start, BlockNumber end)
 
 	/* Recursively scan the tree, starting at the root */
 	if (end > start)
+	{
+		FSM_ROOT_ADDRESS.level = FSM_ROOT_LEVEL(tde_nonce_size);
+
 		(void) fsm_vacuum_page(rel, FSM_ROOT_ADDRESS, start, end, &dummy);
+	}
 }
 
 /******** Internal routines ********/
@@ -372,7 +378,7 @@ fsm_space_avail_to_cat(Size avail)
 
 	Assert(avail < BLCKSZ);
 
-	if (avail >= MaxFSMRequestSize)
+	if (avail >= MaxFSMRequestSize(tde_nonce_size))
 		return 255;
 
 	cat = avail / FSM_CAT_STEP;
@@ -396,7 +402,7 @@ fsm_space_cat_to_avail(uint8 cat)
 {
 	/* The highest category represents exactly MaxFSMRequestSize bytes. */
 	if (cat == 255)
-		return MaxFSMRequestSize;
+		return MaxFSMRequestSize(tde_nonce_size);
 	else
 		return cat * FSM_CAT_STEP;
 }
@@ -411,7 +417,7 @@ fsm_space_needed_to_cat(Size needed)
 	int			cat;
 
 	/* Can't ask for more space than the highest category represents */
-	if (needed > MaxFSMRequestSize)
+	if (needed > MaxFSMRequestSize(tde_nonce_size))
 		elog(ERROR, "invalid FSM request size %zu", needed);
 
 	if (needed == 0)
@@ -441,14 +447,14 @@ fsm_logical_to_physical(FSMAddress addr)
 	 */
 	leafno = addr.logpageno;
 	for (l = 0; l < addr.level; l++)
-		leafno *= SlotsPerFSMPage;
+		leafno *= SlotsPerFSMPage(tde_nonce_size);
 
 	/* Count upper level nodes required to address the leaf page */
 	pages = 0;
-	for (l = 0; l < FSM_TREE_DEPTH; l++)
+	for (l = 0; l < FSM_TREE_DEPTH(tde_nonce_size); l++)
 	{
 		pages += leafno + 1;
-		leafno /= SlotsPerFSMPage;
+		leafno /= SlotsPerFSMPage(tde_nonce_size);
 	}
 
 	/*
@@ -470,8 +476,8 @@ fsm_get_location(BlockNumber heapblk, uint16 *slot)
 	FSMAddress	addr;
 
 	addr.level = FSM_BOTTOM_LEVEL;
-	addr.logpageno = heapblk / SlotsPerFSMPage;
-	*slot = heapblk % SlotsPerFSMPage;
+	addr.logpageno = heapblk / SlotsPerFSMPage(tde_nonce_size);
+	*slot = heapblk % SlotsPerFSMPage(tde_nonce_size);
 
 	return addr;
 }
@@ -483,7 +489,7 @@ static BlockNumber
 fsm_get_heap_blk(FSMAddress addr, uint16 slot)
 {
 	Assert(addr.level == FSM_BOTTOM_LEVEL);
-	return ((unsigned int) addr.logpageno) * SlotsPerFSMPage + slot;
+	return ((unsigned int) addr.logpageno) * SlotsPerFSMPage(tde_nonce_size) + slot;
 }
 
 /*
@@ -495,11 +501,11 @@ fsm_get_parent(FSMAddress child, uint16 *slot)
 {
 	FSMAddress	parent;
 
-	Assert(child.level < FSM_ROOT_LEVEL);
+	Assert(child.level < FSM_ROOT_LEVEL(tde_nonce_size));
 
 	parent.level = child.level + 1;
-	parent.logpageno = child.logpageno / SlotsPerFSMPage;
-	*slot = child.logpageno % SlotsPerFSMPage;
+	parent.logpageno = child.logpageno / SlotsPerFSMPage(tde_nonce_size);
+	*slot = child.logpageno % SlotsPerFSMPage(tde_nonce_size);
 
 	return parent;
 }
@@ -516,7 +522,7 @@ fsm_get_child(FSMAddress parent, uint16 slot)
 	Assert(parent.level > FSM_BOTTOM_LEVEL);
 
 	child.level = parent.level - 1;
-	child.logpageno = parent.logpageno * SlotsPerFSMPage + slot;
+	child.logpageno = parent.logpageno * SlotsPerFSMPage(tde_nonce_size) + slot;
 
 	return child;
 }
@@ -690,7 +696,10 @@ static BlockNumber
 fsm_search(Relation rel, uint8 min_cat)
 {
 	int			restarts = 0;
-	FSMAddress	addr = FSM_ROOT_ADDRESS;
+	FSMAddress	addr;
+
+	FSM_ROOT_ADDRESS.level = FSM_ROOT_LEVEL(tde_nonce_size);
+	addr = FSM_ROOT_ADDRESS;
 
 	for (;;)
 	{
@@ -726,7 +735,7 @@ fsm_search(Relation rel, uint8 min_cat)
 
 			addr = fsm_get_child(addr, slot);
 		}
-		else if (addr.level == FSM_ROOT_LEVEL)
+		else if (addr.level == FSM_ROOT_LEVEL(tde_nonce_size))
 		{
 			/*
 			 * At the root, failure means there's no page with enough free
@@ -840,14 +849,14 @@ fsm_vacuum_page(Relation rel, FSMAddress addr,
 		if (fsm_start.logpageno == addr.logpageno)
 			start_slot = fsm_start_slot;
 		else if (fsm_start.logpageno > addr.logpageno)
-			start_slot = SlotsPerFSMPage;	/* shouldn't get here... */
+			start_slot = SlotsPerFSMPage(tde_nonce_size);	/* shouldn't get here... */
 		else
 			start_slot = 0;
 
 		if (fsm_end.logpageno == addr.logpageno)
 			end_slot = fsm_end_slot;
 		else if (fsm_end.logpageno > addr.logpageno)
-			end_slot = SlotsPerFSMPage - 1;
+			end_slot = SlotsPerFSMPage(tde_nonce_size) - 1;
 		else
 			end_slot = -1;		/* shouldn't get here... */
 
diff --git a/src/backend/storage/freespace/fsmpage.c b/src/backend/storage/freespace/fsmpage.c
index 88ae51e526..c1b5315f3b 100644
--- a/src/backend/storage/freespace/fsmpage.c
+++ b/src/backend/storage/freespace/fsmpage.c
@@ -22,6 +22,7 @@
  */
 #include "postgres.h"
 
+#include "miscadmin.h" /* for tde_nonce_size */
 #include "storage/bufmgr.h"
 #include "storage/fsm_internals.h"
 
@@ -66,7 +67,7 @@ fsm_set_avail(Page page, int slot, uint8 value)
 	FSMPage		fsmpage = (FSMPage) PageGetContents(page);
 	uint8		oldvalue;
 
-	Assert(slot < LeafNodesPerPage);
+	Assert(slot < LeafNodesPerPage(tde_nonce_size));
 
 	oldvalue = fsmpage->fp_nodes[nodeno];
 
@@ -91,7 +92,7 @@ fsm_set_avail(Page page, int slot, uint8 value)
 		rchild = lchild + 1;
 
 		newvalue = fsmpage->fp_nodes[lchild];
-		if (rchild < NodesPerPage)
+		if (rchild < NodesPerPage(tde_nonce_size))
 			newvalue = Max(newvalue,
 						   fsmpage->fp_nodes[rchild]);
 
@@ -123,7 +124,7 @@ fsm_get_avail(Page page, int slot)
 {
 	FSMPage		fsmpage = (FSMPage) PageGetContents(page);
 
-	Assert(slot < LeafNodesPerPage);
+	Assert(slot < LeafNodesPerPage(tde_nonce_size));
 
 	return fsmpage->fp_nodes[NonLeafNodesPerPage + slot];
 }
@@ -179,7 +180,7 @@ restart:
 	 * the last slot on the page.)
 	 */
 	target = fsmpage->fp_next_slot;
-	if (target < 0 || target >= LeafNodesPerPage)
+	if (target < 0 || target >= LeafNodesPerPage(tde_nonce_size))
 		target = 0;
 	target += NonLeafNodesPerPage;
 
@@ -246,14 +247,14 @@ restart:
 	{
 		int			childnodeno = leftchild(nodeno);
 
-		if (childnodeno < NodesPerPage &&
+		if (childnodeno < NodesPerPage(tde_nonce_size) &&
 			fsmpage->fp_nodes[childnodeno] >= minvalue)
 		{
 			nodeno = childnodeno;
 			continue;
 		}
 		childnodeno++;			/* point to right child */
-		if (childnodeno < NodesPerPage &&
+		if (childnodeno < NodesPerPage(tde_nonce_size) &&
 			fsmpage->fp_nodes[childnodeno] >= minvalue)
 		{
 			nodeno = childnodeno;
@@ -316,11 +317,11 @@ fsm_truncate_avail(Page page, int nslots)
 	uint8	   *ptr;
 	bool		changed = false;
 
-	Assert(nslots >= 0 && nslots < LeafNodesPerPage);
+	Assert(nslots >= 0 && nslots < LeafNodesPerPage(tde_nonce_size));
 
 	/* Clear all truncated leaf nodes */
 	ptr = &fsmpage->fp_nodes[NonLeafNodesPerPage + nslots];
-	for (; ptr < &fsmpage->fp_nodes[NodesPerPage]; ptr++)
+	for (; ptr < &fsmpage->fp_nodes[NodesPerPage(tde_nonce_size)]; ptr++)
 	{
 		if (*ptr != 0)
 			changed = true;
@@ -356,10 +357,10 @@ fsm_rebuild_page(Page page)
 		uint8		newvalue = 0;
 
 		/* The first few nodes we examine might have zero or one child. */
-		if (lchild < NodesPerPage)
+		if (lchild < NodesPerPage(tde_nonce_size))
 			newvalue = fsmpage->fp_nodes[lchild];
 
-		if (rchild < NodesPerPage)
+		if (rchild < NodesPerPage(tde_nonce_size))
 			newvalue = Max(newvalue,
 						   fsmpage->fp_nodes[rchild]);
 
diff --git a/src/backend/storage/page/bufpage.c b/src/backend/storage/page/bufpage.c
index 82ca91f597..fe52500a5a 100644
--- a/src/backend/storage/page/bufpage.c
+++ b/src/backend/storage/page/bufpage.c
@@ -43,6 +43,8 @@ PageInit(Page page, Size pageSize, Size specialSize)
 {
 	PageHeader	p = (PageHeader) page;
 
+	specialSize = specialSize + tde_nonce_size;
+
 	specialSize = MAXALIGN(specialSize);
 
 	Assert(pageSize == BLCKSZ);
@@ -295,7 +297,7 @@ PageAddItemExtended(Page page,
 	}
 
 	/* Reject placing items beyond heap boundary, if heap */
-	if ((flags & PAI_IS_HEAP) != 0 && offsetNumber > MaxHeapTuplesPerPage)
+	if ((flags & PAI_IS_HEAP) != 0 && offsetNumber > MaxHeapTuplesPerPage(tde_nonce_size))
 	{
 		elog(WARNING, "can't put more than MaxHeapTuplesPerPage items in a heap page");
 		return InvalidOffsetNumber;
@@ -403,11 +405,22 @@ PageGetTempPageCopySpecial(Page page)
 {
 	Size		pageSize;
 	Page		temp;
+	int			prev_tde_nonce_size;
 
 	pageSize = PageGetPageSize(page);
 	temp = (Page) palloc(pageSize);
 
+	/*
+	 * TDE nonce bytes are copied to temporary page since the source page
+	 * special space is passed to PageInit.
+	 */
+	prev_tde_nonce_size = tde_nonce_size;
+	tde_nonce_size = 0;
+
 	PageInit(temp, pageSize, PageGetSpecialSize(page));
+
+	tde_nonce_size = prev_tde_nonce_size;
+
 	memcpy(PageGetSpecialPointer(temp),
 		   PageGetSpecialPointer(page),
 		   PageGetSpecialSize(page));
@@ -712,7 +725,7 @@ PageRepairFragmentation(Page page)
 	Offset		pd_upper = ((PageHeader) page)->pd_upper;
 	Offset		pd_special = ((PageHeader) page)->pd_special;
 	Offset		last_offset;
-	itemIdCompactData itemidbase[MaxHeapTuplesPerPage];
+	itemIdCompactData itemidbase[MaxHeapTuplesPerPageLimit];
 	itemIdCompact itemidptr;
 	ItemId		lp;
 	int			nline,
@@ -995,7 +1008,7 @@ PageGetHeapFreeSpace(Page page)
 		 * Are there already MaxHeapTuplesPerPage line pointers in the page?
 		 */
 		nline = PageGetMaxOffsetNumber(page);
-		if (nline >= MaxHeapTuplesPerPage)
+		if (nline >= MaxHeapTuplesPerPage(tde_nonce_size))
 		{
 			if (PageHasFreeLinePointers((PageHeader) page))
 			{
@@ -1158,8 +1171,8 @@ PageIndexMultiDelete(Page page, OffsetNumber *itemnos, int nitems)
 	Offset		pd_upper = phdr->pd_upper;
 	Offset		pd_special = phdr->pd_special;
 	Offset		last_offset;
-	itemIdCompactData itemidbase[MaxIndexTuplesPerPage];
-	ItemIdData	newitemids[MaxIndexTuplesPerPage];
+	itemIdCompactData itemidbase[MaxIndexTuplesPerPageLimit];
+	ItemIdData	newitemids[MaxIndexTuplesPerPageLimit];
 	itemIdCompact itemidptr;
 	ItemId		lp;
 	int			nline,
@@ -1171,7 +1184,7 @@ PageIndexMultiDelete(Page page, OffsetNumber *itemnos, int nitems)
 	OffsetNumber offnum;
 	bool		presorted = true;	/* For now */
 
-	Assert(nitems <= MaxIndexTuplesPerPage);
+	Assert(nitems <= MaxIndexTuplesPerPage(tde_nonce_size));
 
 	/*
 	 * If there aren't very many items to delete, then retail
diff --git a/src/backend/utils/adt/selfuncs.c b/src/backend/utils/adt/selfuncs.c
index 37ddda7724..e1c277429d 100644
--- a/src/backend/utils/adt/selfuncs.c
+++ b/src/backend/utils/adt/selfuncs.c
@@ -7739,7 +7739,7 @@ brincostestimate(PlannerInfo *root, IndexPath *path, double loop_count,
 							   BRIN_DEFAULT_PAGES_PER_RANGE), 1.0);
 
 		statsData.pagesPerRange = BRIN_DEFAULT_PAGES_PER_RANGE;
-		statsData.revmapNumPages = (indexRanges / REVMAP_PAGE_MAXITEMS) + 1;
+		statsData.revmapNumPages = (indexRanges / REVMAP_PAGE_MAXITEMS(tde_nonce_size)) + 1;
 	}
 
 	/*
diff --git a/src/backend/utils/adt/tsgistidx.c b/src/backend/utils/adt/tsgistidx.c
index c09eefdda2..3d5dfbf442 100644
--- a/src/backend/utils/adt/tsgistidx.c
+++ b/src/backend/utils/adt/tsgistidx.c
@@ -32,7 +32,7 @@ typedef struct
 } GistTsVectorOptions;
 
 #define SIGLEN_DEFAULT	(31 * 4)
-#define SIGLEN_MAX		GISTMaxIndexKeySize
+#define SIGLEN_MAX		GISTMaxIndexKeySize(tde_nonce_size)
 #define GET_SIGLEN()	(PG_HAS_OPCLASS_OPTIONS() ? \
 						 ((GistTsVectorOptions *) PG_GET_OPCLASS_OPTIONS())->siglen : \
 						 SIGLEN_DEFAULT)
@@ -207,7 +207,7 @@ gtsvector_compress(PG_FUNCTION_ARGS)
 		}
 
 		/* make signature, if array is too long */
-		if (VARSIZE(res) > TOAST_INDEX_TARGET)
+		if (VARSIZE(res) > TOAST_INDEX_TARGET(tde_nonce_size))
 		{
 			SignTSVector *ressign = gtsvector_alloc(SIGNKEY, siglen, NULL);
 
diff --git a/src/bin/pg_resetwal/pg_resetwal.c b/src/bin/pg_resetwal/pg_resetwal.c
index 805dafef07..0be0d53e17 100644
--- a/src/bin/pg_resetwal/pg_resetwal.c
+++ b/src/bin/pg_resetwal/pg_resetwal.c
@@ -56,6 +56,7 @@
 #include "common/restricted_token.h"
 #include "common/string.h"
 #include "getopt_long.h"
+#include "miscadmin.h" /* for tde_nonce_size */
 #include "pg_getopt.h"
 #include "storage/large_object.h"
 
@@ -720,9 +721,10 @@ GuessControlValues(void)
 	ControlFile.xlog_seg_size = DEFAULT_XLOG_SEG_SIZE;
 	ControlFile.nameDataLen = NAMEDATALEN;
 	ControlFile.indexMaxKeys = INDEX_MAX_KEYS;
-	ControlFile.toast_max_chunk_size = TOAST_MAX_CHUNK_SIZE;
+	ControlFile.toast_max_chunk_size = TOAST_MAX_CHUNK_SIZE(0);
 	ControlFile.loblksize = LOBLKSIZE;
 	ControlFile.float8ByVal = FLOAT8PASSBYVAL;
+	ControlFile.tde_nonce_size = 0;
 
 	/*
 	 * XXX eventually, should try to grovel through old XLOG to develop more
diff --git a/src/include/access/brin_page.h b/src/include/access/brin_page.h
index 75de538ed8..8a877ddc83 100644
--- a/src/include/access/brin_page.h
+++ b/src/include/access/brin_page.h
@@ -85,12 +85,12 @@ typedef struct RevmapContents
 	ItemPointerData rm_tids[1];
 } RevmapContents;
 
-#define REVMAP_CONTENT_SIZE \
+#define REVMAP_CONTENT_SIZE(tdeNonceSize) \
 	(BLCKSZ - MAXALIGN(SizeOfPageHeaderData) - \
 	 offsetof(RevmapContents, rm_tids) - \
-	 MAXALIGN(sizeof(BrinSpecialSpace)))
+	 MAXALIGN(sizeof(BrinSpecialSpace) + tdeNonceSize))
 /* max num of items in the array */
-#define REVMAP_PAGE_MAXITEMS \
-	(REVMAP_CONTENT_SIZE / sizeof(ItemPointerData))
+#define REVMAP_PAGE_MAXITEMS(tdeNonceSize) \
+	(REVMAP_CONTENT_SIZE(tdeNonceSize) / sizeof(ItemPointerData))
 
 #endif							/* BRIN_PAGE_H */
diff --git a/src/include/access/ginblock.h b/src/include/access/ginblock.h
index 37d650ac2a..b0fca2e9ed 100644
--- a/src/include/access/ginblock.h
+++ b/src/include/access/ginblock.h
@@ -11,6 +11,7 @@
 #define GINBLOCK_H
 
 #include "access/transam.h"
+#include "miscadmin.h" /* for tde_nonce_size */
 #include "storage/block.h"
 #include "storage/bufpage.h"
 #include "storage/itemptr.h"
@@ -246,11 +247,11 @@ typedef signed char GinNullCategory;
  * currently store the high key explicitly, we just use the rightmost item on
  * the page, so it would actually be enough to fit two items.)
  */
-#define GinMaxItemSize \
+#define GinMaxItemSize(tdeNonceSize) \
 	Min(INDEX_SIZE_MASK, \
 		MAXALIGN_DOWN(((BLCKSZ - \
 						MAXALIGN(SizeOfPageHeaderData + 3 * sizeof(ItemIdData)) - \
-						MAXALIGN(sizeof(GinPageOpaqueData))) / 3)))
+						MAXALIGN(sizeof(GinPageOpaqueData) + tdeNonceSize)) / 3)))
 
 /*
  * Access macros for non-leaf entry tuples
@@ -307,26 +308,27 @@ typedef signed char GinNullCategory;
  * pages are new in 9.4, however, so we can trust them; see
  * GinDataLeafPageGetPostingListSize.
  */
-#define GinDataPageSetDataSize(page, size) \
+#define GinDataPageSetDataSize(page, size, tdeNonceSize) \
 	{ \
-		Assert(size <= GinDataPageMaxDataSize); \
+		Assert(size <= GinDataPageMaxDataSize(tdeNonceSize)); \
 		((PageHeader) page)->pd_lower = (size) + MAXALIGN(SizeOfPageHeaderData) + MAXALIGN(sizeof(ItemPointerData)); \
 	}
 
-#define GinNonLeafDataPageGetFreeSpace(page)	\
-	(GinDataPageMaxDataSize - \
+#define GinNonLeafDataPageGetFreeSpace(page, tdeNonceSize)	\
+	(GinDataPageMaxDataSize(tdeNonceSize) - \
 	 GinPageGetOpaque(page)->maxoff * sizeof(PostingItem))
 
-#define GinDataPageMaxDataSize	\
+#define GinDataPageMaxDataSize(tdeNonceSize)	\
 	(BLCKSZ - MAXALIGN(SizeOfPageHeaderData) \
 	 - MAXALIGN(sizeof(ItemPointerData)) \
-	 - MAXALIGN(sizeof(GinPageOpaqueData)))
+	 - MAXALIGN(sizeof(GinPageOpaqueData) + tdeNonceSize))
 
 /*
  * List pages
  */
-#define GinListPageSize  \
-	( BLCKSZ - SizeOfPageHeaderData - MAXALIGN(sizeof(GinPageOpaqueData)) )
+#define GinListPageSize(tdeNonceSize)  \
+	( BLCKSZ - SizeOfPageHeaderData - \
+	  MAXALIGN(sizeof(GinPageOpaqueData) + tdeNonceSize) )
 
 /*
  * A compressed posting list.
diff --git a/src/include/access/gist.h b/src/include/access/gist.h
index 4b06575d98..30af09234f 100644
--- a/src/include/access/gist.h
+++ b/src/include/access/gist.h
@@ -95,12 +95,13 @@ typedef GISTPageOpaqueData *GISTPageOpaque;
  * makes sense at all.  For multicolumn indexes, user might be able to tune
  * key size using opclass parameters.
  */
-#define GISTMaxIndexTupleSize	\
-	MAXALIGN_DOWN((BLCKSZ - SizeOfPageHeaderData - sizeof(GISTPageOpaqueData)) / \
+#define GISTMaxIndexTupleSize(tdeNonceSize)	\
+	MAXALIGN_DOWN((BLCKSZ - SizeOfPageHeaderData - \
+				   sizeof(GISTPageOpaqueData) - tdeNonceSize) / \
 				  4 - sizeof(ItemIdData))
 
-#define GISTMaxIndexKeySize	\
-	(GISTMaxIndexTupleSize - MAXALIGN(sizeof(IndexTupleData)))
+#define GISTMaxIndexKeySize(tdeNonceSize)	\
+	(GISTMaxIndexTupleSize(tdeNonceSize) - MAXALIGN(sizeof(IndexTupleData)))
 
 /*
  * The page ID is for the convenience of pg_filedump and similar utilities,
diff --git a/src/include/access/gist_private.h b/src/include/access/gist_private.h
index 553d364e2d..b85cc8d1ef 100644
--- a/src/include/access/gist_private.h
+++ b/src/include/access/gist_private.h
@@ -18,6 +18,7 @@
 #include "access/gist.h"
 #include "access/itup.h"
 #include "lib/pairingheap.h"
+#include "miscadmin.h" /* for tde_nonce_size */
 #include "storage/bufmgr.h"
 #include "storage/buffile.h"
 #include "utils/hsearch.h"
@@ -472,8 +473,9 @@ extern void gistadjustmembers(Oid opfamilyoid,
 
 /* gistutil.c */
 
-#define GiSTPageSize   \
-	( BLCKSZ - SizeOfPageHeaderData - MAXALIGN(sizeof(GISTPageOpaqueData)) )
+#define GiSTPageSize(tdeNonceSize)   \
+	( BLCKSZ - SizeOfPageHeaderData - \
+	  MAXALIGN(sizeof(GISTPageOpaqueData) + tdeNonceSize) )
 
 #define GIST_MIN_FILLFACTOR			10
 #define GIST_DEFAULT_FILLFACTOR		90
diff --git a/src/include/access/hash.h b/src/include/access/hash.h
index 1cce865be2..9dbc9d16c4 100644
--- a/src/include/access/hash.h
+++ b/src/include/access/hash.h
@@ -122,7 +122,7 @@ typedef struct HashScanPosData
 	int			lastItem;		/* last valid index in items[] */
 	int			itemIndex;		/* current index in items[] */
 
-	HashScanPosItem items[MaxIndexTuplesPerPage];	/* MUST BE LAST */
+	HashScanPosItem items[MaxIndexTuplesPerPageLimit];	/* MUST BE LAST */
 } HashScanPosData;
 
 #define HashScanPosIsPinned(scanpos) \
@@ -282,11 +282,11 @@ typedef struct HashOptions
 /*
  * Maximum size of a hash index item (it's okay to have only one per page)
  */
-#define HashMaxItemSize(page) \
+#define HashMaxItemSize(page, tdeNonceSize) \
 	MAXALIGN_DOWN(PageGetPageSize(page) - \
 				  SizeOfPageHeaderData - \
 				  sizeof(ItemIdData) - \
-				  MAXALIGN(sizeof(HashPageOpaqueData)))
+				  MAXALIGN(sizeof(HashPageOpaqueData) + tdeNonceSize))
 
 #define INDEX_MOVED_BY_SPLIT_MASK	INDEX_AM_RESERVED_BIT
 
@@ -314,9 +314,10 @@ typedef struct HashOptions
 #define HashPageGetBitmap(page) \
 	((uint32 *) PageGetContents(page))
 
-#define HashGetMaxBitmapSize(page) \
+#define HashGetMaxBitmapSize(page, tdeNonceSize) \
 	(PageGetPageSize((Page) page) - \
-	 (MAXALIGN(SizeOfPageHeaderData) + MAXALIGN(sizeof(HashPageOpaqueData))))
+	 (MAXALIGN(SizeOfPageHeaderData) + \
+	  MAXALIGN(sizeof(HashPageOpaqueData) + tdeNonceSize)))
 
 #define HashPageGetMeta(page) \
 	((HashMetaPage) PageGetContents(page))
diff --git a/src/include/access/heapam.h b/src/include/access/heapam.h
index e63b49fc38..835e6df5da 100644
--- a/src/include/access/heapam.h
+++ b/src/include/access/heapam.h
@@ -74,7 +74,7 @@ typedef struct HeapScanDescData
 	/* these fields only used in page-at-a-time mode and for bitmap scans */
 	int			rs_cindex;		/* current tuple's index in vistuples */
 	int			rs_ntuples;		/* number of visible tuples on page */
-	OffsetNumber rs_vistuples[MaxHeapTuplesPerPage];	/* their offsets */
+	OffsetNumber rs_vistuples[MaxHeapTuplesPerPageLimit];	/* their offsets */
 }			HeapScanDescData;
 typedef struct HeapScanDescData *HeapScanDesc;
 
diff --git a/src/include/access/heaptoast.h b/src/include/access/heaptoast.h
index 8b29f1a986..186b8da682 100644
--- a/src/include/access/heaptoast.h
+++ b/src/include/access/heaptoast.h
@@ -14,17 +14,24 @@
 #define HEAPTOAST_H
 
 #include "access/htup_details.h"
+#include "miscadmin.h" /* for tde_nonce_size */
 #include "storage/lockdefs.h"
 #include "utils/relcache.h"
 
 /*
  * Find the maximum size of a tuple if there are to be N tuples per page.
  */
-#define MaximumBytesPerTuple(tuplesPerPage) \
+#define MaximumBytesPerTupleLimit(tuplesPerPage) \
 	MAXALIGN_DOWN((BLCKSZ - \
 				   MAXALIGN(SizeOfPageHeaderData + (tuplesPerPage) * sizeof(ItemIdData))) \
 				  / (tuplesPerPage))
 
+#define MaximumBytesPerTuple(tuplesPerPage, tdeNonceSize) \
+	MAXALIGN_DOWN((BLCKSZ - \
+				   MAXALIGN(SizeOfPageHeaderData + (tuplesPerPage) * sizeof(ItemIdData)) - \
+				   MAXALIGN(tdeNonceSize)) \
+				  / (tuplesPerPage))
+
 /*
  * These symbols control toaster activation.  If a tuple is larger than
  * TOAST_TUPLE_THRESHOLD, we will try to toast it down to no more than
@@ -45,9 +52,14 @@
  */
 #define TOAST_TUPLES_PER_PAGE	4
 
-#define TOAST_TUPLE_THRESHOLD	MaximumBytesPerTuple(TOAST_TUPLES_PER_PAGE)
+#define TOAST_TUPLE_THRESHOLD(tdeNonceSize)	MaximumBytesPerTuple(TOAST_TUPLES_PER_PAGE, tdeNonceSize)
+
+#define TOAST_TUPLE_THRESHOLD_MAX_LIMIT	MaximumBytesPerTupleLimit(TOAST_TUPLES_PER_PAGE)
+
+#define TOAST_TUPLE_TARGET_MAX_LIMIT		TOAST_TUPLE_THRESHOLD_MAX_LIMIT
+
+#define TOAST_TUPLE_TARGET(tdeNonceSize)	TOAST_TUPLE_THRESHOLD(tdeNonceSize)
 
-#define TOAST_TUPLE_TARGET		TOAST_TUPLE_THRESHOLD
 
 /*
  * The code will also consider moving MAIN data out-of-line, but only as a
@@ -58,14 +70,16 @@
  */
 #define TOAST_TUPLES_PER_PAGE_MAIN	1
 
-#define TOAST_TUPLE_TARGET_MAIN MaximumBytesPerTuple(TOAST_TUPLES_PER_PAGE_MAIN)
+#define TOAST_TUPLE_TARGET_MAIN_MAX_LIMIT MaximumBytesPerTupleLimit(TOAST_TUPLES_PER_PAGE_MAIN)
+
+#define TOAST_TUPLE_TARGET_MAIN(tdeNonceSize) MaximumBytesPerTuple(TOAST_TUPLES_PER_PAGE_MAIN, tdeNonceSize)
 
 /*
  * If an index value is larger than TOAST_INDEX_TARGET, we will try to
  * compress it (we can't move it out-of-line, however).  Note that this
  * number is per-datum, not per-tuple, for simplicity in index_form_tuple().
  */
-#define TOAST_INDEX_TARGET		(MaxHeapTupleSize / 16)
+#define TOAST_INDEX_TARGET(tdeNonceSize)		(MaxHeapTupleSize(tdeNonceSize) / 16)
 
 /*
  * When we store an oversize datum externally, we divide it into chunks
@@ -79,10 +93,19 @@
  */
 #define EXTERN_TUPLES_PER_PAGE	4	/* tweak only this */
 
-#define EXTERN_TUPLE_MAX_SIZE	MaximumBytesPerTuple(EXTERN_TUPLES_PER_PAGE)
+#define EXTERN_TUPLE_MAX_SIZE(tdeNonceSize)	MaximumBytesPerTuple(EXTERN_TUPLES_PER_PAGE, tdeNonceSize)
+
+#define EXTERN_TUPLE_MAX_SIZE_LIMIT	MaximumBytesPerTupleLimit(EXTERN_TUPLES_PER_PAGE)
+
+#define TOAST_MAX_CHUNK_SIZE_LIMIT	\
+	(EXTERN_TUPLE_MAX_SIZE_LIMIT -							\
+	 MAXALIGN(SizeofHeapTupleHeader) -					\
+	 sizeof(Oid) -										\
+	 sizeof(int32) -									\
+	 VARHDRSZ)
 
-#define TOAST_MAX_CHUNK_SIZE	\
-	(EXTERN_TUPLE_MAX_SIZE -							\
+#define TOAST_MAX_CHUNK_SIZE(tdeNonceSize)	\
+	(EXTERN_TUPLE_MAX_SIZE(tdeNonceSize) -							\
 	 MAXALIGN(SizeofHeapTupleHeader) -					\
 	 sizeof(Oid) -										\
 	 sizeof(int32) -									\
diff --git a/src/include/access/htup_details.h b/src/include/access/htup_details.h
index 960772f76b..5a800fe971 100644
--- a/src/include/access/htup_details.h
+++ b/src/include/access/htup_details.h
@@ -18,6 +18,7 @@
 #include "access/transam.h"
 #include "access/tupdesc.h"
 #include "access/tupmacs.h"
+#include "miscadmin.h" /* for tde_nonce_size */
 #include "storage/bufpage.h"
 
 /*
@@ -556,7 +557,10 @@ do { \
  * ItemIds and tuples have different alignment requirements, don't assume that
  * you can, say, fit 2 tuples of size MaxHeapTupleSize/2 on the same page.
  */
-#define MaxHeapTupleSize  (BLCKSZ - MAXALIGN(SizeOfPageHeaderData + sizeof(ItemIdData)))
+#define MaxHeapTupleSizeLimit  (BLCKSZ - MAXALIGN(SizeOfPageHeaderData + \
+						   sizeof(ItemIdData)))
+#define MaxHeapTupleSize(tdeNonceSize)  (BLCKSZ - MAXALIGN(SizeOfPageHeaderData + \
+						   sizeof(ItemIdData)) - MAXALIGN(tdeNonceSize))
 #define MinHeapTupleSize  MAXALIGN(SizeofHeapTupleHeader)
 
 /*
@@ -570,10 +574,14 @@ do { \
  * pointers to this anyway, to avoid excessive line-pointer bloat and not
  * require increases in the size of work arrays.
  */
-#define MaxHeapTuplesPerPage	\
+#define MaxHeapTuplesPerPageLimit	\
 	((int) ((BLCKSZ - SizeOfPageHeaderData) / \
 			(MAXALIGN(SizeofHeapTupleHeader) + sizeof(ItemIdData))))
 
+#define MaxHeapTuplesPerPage(tdeNonceSize)	\
+	((int) ((BLCKSZ - SizeOfPageHeaderData - MAXALIGN(tdeNonceSize)) / \
+			(MAXALIGN(SizeofHeapTupleHeader) + sizeof(ItemIdData))))
+
 /*
  * MaxAttrSize is a somewhat arbitrary upper limit on the declared size of
  * data fields of char(n) and similar types.  It need not have anything
diff --git a/src/include/access/itup.h b/src/include/access/itup.h
index 1917375cde..c18544e9a2 100644
--- a/src/include/access/itup.h
+++ b/src/include/access/itup.h
@@ -142,10 +142,13 @@ typedef IndexAttributeBitMapData * IndexAttributeBitMap;
  * estimated here, seemingly allowing one more tuple than estimated here.
  * But such a page always has at least MAXALIGN special space, so we're safe.
  */
-#define MaxIndexTuplesPerPage	\
+#define MaxIndexTuplesPerPageLimit	\
 	((int) ((BLCKSZ - SizeOfPageHeaderData) / \
 			(MAXALIGN(sizeof(IndexTupleData) + 1) + sizeof(ItemIdData))))
 
+#define MaxIndexTuplesPerPage(tdeNonceSize)	\
+	((int) ((BLCKSZ - SizeOfPageHeaderData - MAXALIGN(tdeNonceSize)) / \
+			(MAXALIGN(sizeof(IndexTupleData) + 1) + sizeof(ItemIdData))))
 
 /* routines in indextuple.c */
 extern IndexTuple index_form_tuple(TupleDesc tupleDescriptor,
